// $ANTLR 2.7.1: "CM2mdlTreeWalker.g" -> "CM2mdlTreeWalker.java"$
import java.io.*;
import java.lang.*;
import java.util.*;
import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


public class CM2mdlTreeWalker extends antlr.TreeParser
       implements CM2mdlTreeWalkerTokenTypes
 {
public CM2mdlTreeWalker() {
	tokenNames = _tokenNames;
}

	public final  _model  model(AST _t) throws RecognitionException {
		 _model mod ;

		AST model_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST model_AST = null;

		String M;
		float V, P;

		Vector hlist; // Vector of half spaces
		Vector clist; // Vector of clocks
		Vector mac_list; // Vector of machines

		String aregion, iset;

		mod = new _model();


		try {      // for error handling
			AST __t2 = _t;
			AST tmp1_AST = null;
			AST tmp1_AST_in = null;
			tmp1_AST = (AST)astFactory.create((AST)_t);
			tmp1_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp1_AST);
			ASTPair __currentAST2 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,LEFTBRACE);
			_t = _t.getFirstChild();
			M=modelname(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			V=variables(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			P=parameters(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			hlist=halfspace_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			mac_list=machine_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			aregion=analysis_region(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			iset=initial_set(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp2_AST = null;
			AST tmp2_AST_in = null;
			tmp2_AST = (AST)astFactory.create((AST)_t);
			tmp2_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp2_AST);
			match(_t,RIGHTBRACE);
			_t = _t.getNextSibling();
			currentAST = __currentAST2;
			_t = __t2;
			_t = _t.getNextSibling();

				           mod = new _model(M, V, P, hlist,
				                                        mac_list, aregion, iset);
				           //System.out.println("IN model");

			model_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = model_AST;
		_retTree = _t;
		return mod ;
	}

	public final  String  modelname(AST _t) throws RecognitionException {
		 String temp_s ;

		AST modelname_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST modelname_AST = null;
		AST temp_a = null;
		AST temp_a_AST = null;

		temp_s = new String();


		try {      // for error handling
			temp_a = (AST)_t;
			temp_a_AST = (AST)astFactory.create(temp_a);
			astFactory.addASTChild(currentAST, temp_a_AST);
			match(_t,STRING);
			_t = _t.getNextSibling();

				                   temp_s = new String(temp_a.toString());
				                   //System.out.println("Reducing modelname");

			modelname_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = modelname_AST;
		_retTree = _t;
		return temp_s ;
	}

	public final  float  variables(AST _t) throws RecognitionException {
		 float a ;

		AST variables_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST variables_AST = null;

		float n;
		a = 0;


		try {      // for error handling
			AST __t5 = _t;
			AST tmp3_AST = null;
			AST tmp3_AST_in = null;
			tmp3_AST = (AST)astFactory.create((AST)_t);
			tmp3_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp3_AST);
			ASTPair __currentAST5 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,VARIABLES);
			_t = _t.getFirstChild();
			n=nnumber(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST5;
			_t = __t5;
			_t = _t.getNextSibling();

			a = n;
				                   //System.out.println("Reducing variables");

			variables_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = variables_AST;
		_retTree = _t;
		return a ;
	}

	public final  float  parameters(AST _t) throws RecognitionException {
		 float a;

		AST parameters_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST parameters_AST = null;

		float n;
		a = 0;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case COLON:
			{
				AST __t7 = _t;
				AST tmp4_AST = null;
				AST tmp4_AST_in = null;
				tmp4_AST = (AST)astFactory.create((AST)_t);
				tmp4_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp4_AST);
				ASTPair __currentAST7 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,COLON);
				_t = _t.getFirstChild();
				AST tmp5_AST = null;
				AST tmp5_AST_in = null;
				tmp5_AST = (AST)astFactory.create((AST)_t);
				tmp5_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp5_AST);
				match(_t,PARAMETERS);
				_t = _t.getNextSibling();
				n=nnumber(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST7;
				_t = __t7;
				_t = _t.getNextSibling();

				a = n ;
					                   //System.out.println("Reducing parameters");

				parameters_AST = (AST)currentAST.root;
				break;
			}
			case HALFSPACES:
			{

					                   //System.out.println("Reducing parameters");

				parameters_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = parameters_AST;
		_retTree = _t;
		return a;
	}

	public final  Vector  halfspace_list(AST _t) throws RecognitionException {
		 Vector hspace_vector ;

		AST halfspace_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST halfspace_list_AST = null;

		_half_space hspace;
		// space_vector is a Vector of "_half_space" objects

		hspace_vector = new Vector(3,2);
		Vector hlist;


		try {      // for error handling
			AST __t9 = _t;
			AST tmp6_AST = null;
			AST tmp6_AST_in = null;
			tmp6_AST = (AST)astFactory.create((AST)_t);
			tmp6_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp6_AST);
			ASTPair __currentAST9 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,HALFSPACES);
			_t = _t.getFirstChild();
			hspace=halfspace(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			hlist=halfspace_list_entries(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST9;
			_t = __t9;
			_t = _t.getNextSibling();

			hlist.addElement(hspace);
			hspace_vector = hlist;
				              //System.out.println("Reducing halfspace_list ");

			halfspace_list_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = halfspace_list_AST;
		_retTree = _t;
		return hspace_vector ;
	}

	public final  Vector  machine_list(AST _t) throws RecognitionException {
		 Vector mac_list ;

		AST machine_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST machine_list_AST = null;

		mac_list = new Vector(3,2);

		Vector mac_liste;


		try {      // for error handling
			AST __t19 = _t;
			AST tmp7_AST = null;
			AST tmp7_AST_in = null;
			tmp7_AST = (AST)astFactory.create((AST)_t);
			tmp7_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp7_AST);
			ASTPair __currentAST19 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,MACHINE);
			_t = _t.getFirstChild();
			mac_liste=machine_list_entries(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST19;
			_t = __t19;
			_t = _t.getNextSibling();

			mac_list = mac_liste;

			machine_list_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = machine_list_AST;
		_retTree = _t;
		return mac_list ;
	}

	public final  String  analysis_region(AST _t) throws RecognitionException {
		 String aregion ;

		AST analysis_region_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST analysis_region_AST = null;

		String bfunc;

		aregion = " ";


		try {      // for error handling
			AST __t99 = _t;
			AST tmp8_AST = null;
			AST tmp8_AST_in = null;
			tmp8_AST = (AST)astFactory.create((AST)_t);
			tmp8_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp8_AST);
			ASTPair __currentAST99 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,ANALYSIS_REGION);
			_t = _t.getFirstChild();
			bfunc=boolean_function(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST99;
			_t = __t99;
			_t = _t.getNextSibling();

			aregion = bfunc;

			analysis_region_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = analysis_region_AST;
		_retTree = _t;
		return aregion ;
	}

	public final  String  initial_set(AST _t) throws RecognitionException {
		 String iset ;

		AST initial_set_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST initial_set_AST = null;

		String bfunc;

		iset = " ";


		try {      // for error handling
			AST __t101 = _t;
			AST tmp9_AST = null;
			AST tmp9_AST_in = null;
			tmp9_AST = (AST)astFactory.create((AST)_t);
			tmp9_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp9_AST);
			ASTPair __currentAST101 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,INITIAL_SET);
			_t = _t.getFirstChild();
			bfunc=boolean_function(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST101;
			_t = __t101;
			_t = _t.getNextSibling();

			iset = bfunc;

			initial_set_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = initial_set_AST;
		_retTree = _t;
		return iset ;
	}

	public final  float  nnumber(AST _t) throws RecognitionException {
		 float a ;

		AST nnumber_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST nnumber_AST = null;
		AST o = null;
		AST o_AST = null;
		AST n = null;
		AST n_AST = null;
		AST m = null;
		AST m_AST = null;

		a = 0;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case OP:
			{
				AST __t117 = _t;
				o = _t==ASTNULL ? null :(AST)_t;
				o_AST = (AST)astFactory.create(o);
				astFactory.addASTChild(currentAST, o_AST);
				ASTPair __currentAST117 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,OP);
				_t = _t.getFirstChild();
				n = (AST)_t;
				n_AST = (AST)astFactory.create(n);
				astFactory.addASTChild(currentAST, n_AST);
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				currentAST = __currentAST117;
				_t = __t117;
				_t = _t.getNextSibling();

				a = Float.parseFloat(n.toString());
				if(o.toString().equals("-")) a = -a;

				nnumber_AST = (AST)currentAST.root;
				break;
			}
			case FLOAT:
			{
				m = (AST)_t;
				m_AST = (AST)astFactory.create(m);
				astFactory.addASTChild(currentAST, m_AST);
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				a = Float.parseFloat(m.toString());
				nnumber_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = nnumber_AST;
		_retTree = _t;
		return a ;
	}

	public final  _half_space  halfspace(AST _t) throws RecognitionException {
		 _half_space hspace ;

		AST halfspace_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST halfspace_AST = null;
		AST s = null;
		AST s_AST = null;

		float f;
		char r;
		Vector v;
		hspace = new _half_space();


		try {      // for error handling
			AST __t13 = _t;
			AST tmp10_AST = null;
			AST tmp10_AST_in = null;
			tmp10_AST = (AST)astFactory.create((AST)_t);
			tmp10_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp10_AST);
			ASTPair __currentAST13 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,COLON);
			_t = _t.getFirstChild();
			s = (AST)_t;
			s_AST = (AST)astFactory.create(s);
			astFactory.addASTChild(currentAST, s_AST);
			match(_t,STRING);
			_t = _t.getNextSibling();
			v=vector(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			r=relation(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			f=fnumber(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST13;
			_t = __t13;
			_t = _t.getNextSibling();

			hspace = new _half_space(s.toString(), r, f, v);
				             // System.out.println("Reducing halfspace");

			halfspace_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = halfspace_AST;
		_retTree = _t;
		return hspace ;
	}

	public final  Vector  halfspace_list_entries(AST _t) throws RecognitionException {
		 Vector hspace_vector ;

		AST halfspace_list_entries_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST halfspace_list_entries_AST = null;

		_half_space hspace;
		// space_vector is a Vector of "_half_space" objects

		hspace_vector = new Vector(3,2);
		Vector hlist;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case HALFSPACE_LIST_ENTRIES_IMG:
			{
				AST __t11 = _t;
				AST tmp11_AST = null;
				AST tmp11_AST_in = null;
				tmp11_AST = (AST)astFactory.create((AST)_t);
				tmp11_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp11_AST);
				ASTPair __currentAST11 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,HALFSPACE_LIST_ENTRIES_IMG);
				_t = _t.getFirstChild();
				hspace=halfspace(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				hlist=halfspace_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST11;
				_t = __t11;
				_t = _t.getNextSibling();

				hlist.addElement(hspace);
				hspace_vector = hlist;
					             // System.out.println("Reducing halfspace_list_entries ");

				halfspace_list_entries_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{

				hspace_vector = new Vector(3,2);
					            //  System.out.println("Reducing halfspace_list_entries blank ");

				halfspace_list_entries_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = halfspace_list_entries_AST;
		_retTree = _t;
		return hspace_vector ;
	}

	public final  Vector  vector(AST _t) throws RecognitionException {
		 Vector vec ;

		AST vector_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST vector_AST = null;

		float f;
		Vector f_list;
		vec = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case VECTOR_IMG:
			{
				AST __t15 = _t;
				AST tmp12_AST = null;
				AST tmp12_AST_in = null;
				tmp12_AST = (AST)astFactory.create((AST)_t);
				tmp12_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp12_AST);
				ASTPair __currentAST15 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,VECTOR_IMG);
				_t = _t.getFirstChild();
				f=fnumber(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				f_list=fnumber_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST15;
				_t = __t15;
				_t = _t.getNextSibling();
				f_list.addElement(new Float(f));
				vec = f_list ;
					                            //   System.out.println("Reducing vector");

				vector_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case SEMI:
			case OP:
			case SMALLER:
			case GREATER:
			case EQUAL:
			case FLOAT:
			{

				//    System.out.println("Reducing vector blank");

				vector_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = vector_AST;
		_retTree = _t;
		return vec ;
	}

	public final  char  relation(AST _t) throws RecognitionException {
		 char c ;

		AST relation_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST relation_AST = null;

		c = ' ';


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SMALLER:
			{
				AST tmp13_AST = null;
				AST tmp13_AST_in = null;
				tmp13_AST = (AST)astFactory.create((AST)_t);
				tmp13_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp13_AST);
				match(_t,SMALLER);
				_t = _t.getNextSibling();
				c = '<';
				relation_AST = (AST)currentAST.root;
				break;
			}
			case GREATER:
			{
				AST tmp14_AST = null;
				AST tmp14_AST_in = null;
				tmp14_AST = (AST)astFactory.create((AST)_t);
				tmp14_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp14_AST);
				match(_t,GREATER);
				_t = _t.getNextSibling();
				c = '>';
				relation_AST = (AST)currentAST.root;
				break;
			}
			case EQUAL:
			{
				AST tmp15_AST = null;
				AST tmp15_AST_in = null;
				tmp15_AST = (AST)astFactory.create((AST)_t);
				tmp15_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp15_AST);
				match(_t,EQUAL);
				_t = _t.getNextSibling();
				c = '=';
				relation_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = relation_AST;
		_retTree = _t;
		return c ;
	}

	public final float  fnumber(AST _t) throws RecognitionException {
		float a ;

		AST fnumber_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fnumber_AST = null;
		AST o = null;
		AST o_AST = null;
		AST n = null;
		AST n_AST = null;
		AST m = null;
		AST m_AST = null;

		a = 0;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case OP:
			{
				AST __t119 = _t;
				o = _t==ASTNULL ? null :(AST)_t;
				o_AST = (AST)astFactory.create(o);
				astFactory.addASTChild(currentAST, o_AST);
				ASTPair __currentAST119 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,OP);
				_t = _t.getFirstChild();
				n = (AST)_t;
				n_AST = (AST)astFactory.create(n);
				astFactory.addASTChild(currentAST, n_AST);
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				currentAST = __currentAST119;
				_t = __t119;
				_t = _t.getNextSibling();
				a = Float.parseFloat(n.toString());
				if(o.toString().equals("-")) a = -a;
				// System.out.println(n.toString());

				fnumber_AST = (AST)currentAST.root;
				break;
			}
			case FLOAT:
			{
				m = (AST)_t;
				m_AST = (AST)astFactory.create(m);
				astFactory.addASTChild(currentAST, m_AST);
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				a = Float.parseFloat(m.toString());
				// System.out.println(m.toString());

				fnumber_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = fnumber_AST;
		_retTree = _t;
		return a ;
	}

	public final  Vector  fnumber_list_entries(AST _t) throws RecognitionException {
		 Vector vec ;

		AST fnumber_list_entries_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fnumber_list_entries_AST = null;

		float f;
		Vector f_list;
		vec = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case COMMA:
			{
				AST __t17 = _t;
				AST tmp16_AST = null;
				AST tmp16_AST_in = null;
				tmp16_AST = (AST)astFactory.create((AST)_t);
				tmp16_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp16_AST);
				ASTPair __currentAST17 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,COMMA);
				_t = _t.getFirstChild();
				f=fnumber(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				f_list=fnumber_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST17;
				_t = __t17;
				_t = _t.getNextSibling();
				f_list.addElement(new Float(f));
				vec = f_list ;
					                            //   System.out.println("Reducing fnumber_list_entries");

				fnumber_list_entries_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{

				//    System.out.println("Reducing fnumber_list_entries blank");

				fnumber_list_entries_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = fnumber_list_entries_AST;
		_retTree = _t;
		return vec ;
	}

	public final  Vector  machine_list_entries(AST _t) throws RecognitionException {
		 Vector mac_liste ;

		AST machine_list_entries_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST machine_list_entries_AST = null;

		mac_liste = new Vector(3,2);

		Vector temp_mac_liste;
		_machine mac;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case MACHINE_LIST_ENTRIES_IMG:
			{
				AST __t21 = _t;
				AST tmp17_AST = null;
				AST tmp17_AST_in = null;
				tmp17_AST = (AST)astFactory.create((AST)_t);
				tmp17_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp17_AST);
				ASTPair __currentAST21 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,MACHINE_LIST_ENTRIES_IMG);
				_t = _t.getFirstChild();
				mac=machine(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_mac_liste=machine_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST21;
				_t = __t21;
				_t = _t.getNextSibling();

				temp_mac_liste.addElement(mac);
				mac_liste = temp_mac_liste;

				machine_list_entries_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				machine_list_entries_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = machine_list_entries_AST;
		_retTree = _t;
		return mac_liste ;
	}

	public final  _machine  machine(AST _t) throws RecognitionException {
		 _machine mac ;

		AST machine_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST machine_AST = null;
		AST s = null;
		AST s_AST = null;

		String ini_loc;
		Vector vlist;
		Vector llist;
		Vector elist;

		mac = new _machine();


		try {      // for error handling
			AST __t23 = _t;
			s = _t==ASTNULL ? null :(AST)_t;
			s_AST = (AST)astFactory.create(s);
			astFactory.addASTChild(currentAST, s_AST);
			ASTPair __currentAST23 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,STRING);
			_t = _t.getFirstChild();
			vlist=variable_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			elist=event_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			llist=location_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			ini_loc=initial_location(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST23;
			_t = __t23;
			_t = _t.getNextSibling();

			mac = new _machine(s.toString(), vlist, llist, ini_loc, elist);

			machine_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = machine_AST;
		_retTree = _t;
		return mac ;
	}

	public final  Vector  variable_list(AST _t) throws RecognitionException {
		 Vector vlist ;

		AST variable_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST variable_list_AST = null;

		float f;
		Vector f_list;

		vlist = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case VARIABLE:
			{
				AST __t33 = _t;
				AST tmp18_AST = null;
				AST tmp18_AST_in = null;
				tmp18_AST = (AST)astFactory.create((AST)_t);
				tmp18_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp18_AST);
				ASTPair __currentAST33 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,VARIABLE);
				_t = _t.getFirstChild();
				f=fnumber(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				f_list=fnumber_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST33;
				_t = __t33;
				_t = _t.getNextSibling();

				f_list.addElement(new Float(f));
				vlist = f_list;

				variable_list_AST = (AST)currentAST.root;
				break;
			}
			case EVENTS:
			case LOCATIONS:
			{
				;
				variable_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = variable_list_AST;
		_retTree = _t;
		return vlist ;
	}

	public final  Vector  event_list(AST _t) throws RecognitionException {
		 Vector elist;

		AST event_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST event_list_AST = null;

		elist = new Vector(3,2);

		Vector ielist, oelist;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case EVENTS:
			{
				AST __t25 = _t;
				AST tmp19_AST = null;
				AST tmp19_AST_in = null;
				tmp19_AST = (AST)astFactory.create((AST)_t);
				tmp19_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp19_AST);
				ASTPair __currentAST25 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,EVENTS);
				_t = _t.getFirstChild();
				ielist=input_event_list(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				AST tmp20_AST = null;
				AST tmp20_AST_in = null;
				tmp20_AST = (AST)astFactory.create((AST)_t);
				tmp20_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp20_AST);
				match(_t,SEMI);
				_t = _t.getNextSibling();
				oelist=output_event_list(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST25;
				_t = __t25;
				_t = _t.getNextSibling();

				elist.addElement(ielist);
				elist.addElement(oelist);

				//System.out.println("GOT event_list !!!");

				event_list_AST = (AST)currentAST.root;
				break;
			}
			case LOCATIONS:
			{
				event_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = event_list_AST;
		_retTree = _t;
		return elist;
	}

	public final  Vector  location_list(AST _t) throws RecognitionException {
		 Vector llist ;

		AST location_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST location_list_AST = null;

		llist = new Vector(3,2);

		Vector lliste;


		try {      // for error handling
			AST __t35 = _t;
			AST tmp21_AST = null;
			AST tmp21_AST_in = null;
			tmp21_AST = (AST)astFactory.create((AST)_t);
			tmp21_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp21_AST);
			ASTPair __currentAST35 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,LOCATIONS);
			_t = _t.getFirstChild();
			lliste=location_list_entries(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST35;
			_t = __t35;
			_t = _t.getNextSibling();

			llist = lliste;

			location_list_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = location_list_AST;
		_retTree = _t;
		return llist ;
	}

	public final  String  initial_location(AST _t) throws RecognitionException {
		 String ini_loc ;

		AST initial_location_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST initial_location_AST = null;
		AST s = null;
		AST s_AST = null;

		ini_loc = " ";


		try {      // for error handling
			AST __t37 = _t;
			AST tmp22_AST = null;
			AST tmp22_AST_in = null;
			tmp22_AST = (AST)astFactory.create((AST)_t);
			tmp22_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp22_AST);
			ASTPair __currentAST37 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,INITIAL_LOCATION);
			_t = _t.getFirstChild();
			s = (AST)_t;
			s_AST = (AST)astFactory.create(s);
			astFactory.addASTChild(currentAST, s_AST);
			match(_t,STRING);
			_t = _t.getNextSibling();
			currentAST = __currentAST37;
			_t = __t37;
			_t = _t.getNextSibling();

			ini_loc = s.toString();

			initial_location_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = initial_location_AST;
		_retTree = _t;
		return ini_loc ;
	}

	public final  Vector  input_event_list(AST _t) throws RecognitionException {
		 Vector iev_list ;

		AST input_event_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST input_event_list_AST = null;
		AST s = null;
		AST s_AST = null;

		Vector ev_list;
		iev_list = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STRING:
			{
				AST __t27 = _t;
				s = _t==ASTNULL ? null :(AST)_t;
				s_AST = (AST)astFactory.create(s);
				astFactory.addASTChild(currentAST, s_AST);
				ASTPair __currentAST27 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,STRING);
				_t = _t.getFirstChild();
				ev_list=event_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST27;
				_t = __t27;
				_t = _t.getNextSibling();

				ev_list.addElement(s.toString());
				iev_list = ev_list;

				// System.out.println("GOT input event list !!!!");

				input_event_list_AST = (AST)currentAST.root;
				break;
			}
			case SEMI:
			{
				;
				input_event_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = input_event_list_AST;
		_retTree = _t;
		return iev_list ;
	}

	public final  Vector  output_event_list(AST _t) throws RecognitionException {
		 Vector oev_list ;

		AST output_event_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST output_event_list_AST = null;
		AST s = null;
		AST s_AST = null;

		Vector ev_list;
		oev_list = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STRING:
			{
				AST __t29 = _t;
				s = _t==ASTNULL ? null :(AST)_t;
				s_AST = (AST)astFactory.create(s);
				astFactory.addASTChild(currentAST, s_AST);
				ASTPair __currentAST29 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,STRING);
				_t = _t.getFirstChild();
				ev_list=event_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST29;
				_t = __t29;
				_t = _t.getNextSibling();

				ev_list.addElement(s.toString());
				oev_list = ev_list;

				// System.out.println("GOT output event list !!!!");

				output_event_list_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				output_event_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = output_event_list_AST;
		_retTree = _t;
		return oev_list ;
	}

	public final  Vector  event_list_entries(AST _t) throws RecognitionException {
		 Vector ev_list ;

		AST event_list_entries_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST event_list_entries_AST = null;
		AST s = null;
		AST s_AST = null;

		Vector elist;
		ev_list = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STRING:
			{
				AST __t31 = _t;
				s = _t==ASTNULL ? null :(AST)_t;
				s_AST = (AST)astFactory.create(s);
				astFactory.addASTChild(currentAST, s_AST);
				ASTPair __currentAST31 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,STRING);
				_t = _t.getFirstChild();
				elist=event_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST31;
				_t = __t31;
				_t = _t.getNextSibling();

				elist.addElement(s.toString());
				ev_list = elist;

				event_list_entries_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				event_list_entries_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = event_list_entries_AST;
		_retTree = _t;
		return ev_list ;
	}

	public final  Vector  location_list_entries(AST _t) throws RecognitionException {
		 Vector llist ;

		AST location_list_entries_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST location_list_entries_AST = null;

		Vector temp_llist;
		_location loc;

		llist = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LOCATION_LIST_ENTRIES_IMG:
			{
				AST __t39 = _t;
				AST tmp23_AST = null;
				AST tmp23_AST_in = null;
				tmp23_AST = (AST)astFactory.create((AST)_t);
				tmp23_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp23_AST);
				ASTPair __currentAST39 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,LOCATION_LIST_ENTRIES_IMG);
				_t = _t.getFirstChild();
				loc=location(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_llist=location_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST39;
				_t = __t39;
				_t = _t.getNextSibling();

				temp_llist.addElement(loc);
				llist = temp_llist;

				location_list_entries_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				location_list_entries_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = location_list_entries_AST;
		_retTree = _t;
		return llist ;
	}

	public final  _location  location(AST _t) throws RecognitionException {
		 _location loc ;

		AST location_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST location_AST = null;
		AST s = null;
		AST s_AST = null;

		String inv,par_con;

		Vector tlist;
		_behaviour bhvr;

		loc = new _location();


		try {      // for error handling
			AST __t41 = _t;
			s = _t==ASTNULL ? null :(AST)_t;
			s_AST = (AST)astFactory.create(s);
			astFactory.addASTChild(currentAST, s_AST);
			ASTPair __currentAST41 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,STRING);
			_t = _t.getFirstChild();
			bhvr=behaviour(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			inv=invariant(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			par_con=parameter_constraint(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			tlist=transition_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST41;
			_t = __t41;
			_t = _t.getNextSibling();

			loc = new _location(s.toString(), bhvr, inv, par_con, tlist);

			location_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = location_AST;
		_retTree = _t;
		return loc ;
	}

	public final  _behaviour  behaviour(AST _t) throws RecognitionException {
		 _behaviour bhvr ;

		AST behaviour_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST behaviour_AST = null;
		AST i = null;
		AST i_AST = null;
		AST l = null;
		AST l_AST = null;
		AST n = null;
		AST n_AST = null;

		_linearmap lmap;
		Vector rlist;
		Vector nlmap;

		bhvr = new _behaviour();


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case INTEGRATOR:
			{
				AST __t43 = _t;
				i = _t==ASTNULL ? null :(AST)_t;
				i_AST = (AST)astFactory.create(i);
				astFactory.addASTChild(currentAST, i_AST);
				ASTPair __currentAST43 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,INTEGRATOR);
				_t = _t.getFirstChild();
				rlist=rate_list(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST43;
				_t = __t43;
				_t = _t.getNextSibling();

				bhvr = new _behaviour(i.toString(),rlist);

				behaviour_AST = (AST)currentAST.root;
				break;
			}
			case LINEAR:
			{
				AST __t44 = _t;
				l = _t==ASTNULL ? null :(AST)_t;
				l_AST = (AST)astFactory.create(l);
				astFactory.addASTChild(currentAST, l_AST);
				ASTPair __currentAST44 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,LINEAR);
				_t = _t.getFirstChild();
				lmap=linearmap(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST44;
				_t = __t44;
				_t = _t.getNextSibling();

				bhvr = new _behaviour(l.toString(),lmap);

				behaviour_AST = (AST)currentAST.root;
				break;
			}
			case NONLINEAR:
			{
				AST __t45 = _t;
				n = _t==ASTNULL ? null :(AST)_t;
				n_AST = (AST)astFactory.create(n);
				astFactory.addASTChild(currentAST, n_AST);
				ASTPair __currentAST45 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,NONLINEAR);
				_t = _t.getFirstChild();
				nlmap=nonlinearmap(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST45;
				_t = __t45;
				_t = _t.getNextSibling();

				bhvr = new _behaviour(n.toString(),nlmap);

				behaviour_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case INVARIANT:
			case PAR_CONSTRAINT:
			case TRANSITIONS:
			{
				;
				behaviour_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = behaviour_AST;
		_retTree = _t;
		return bhvr ;
	}

	public final  String  invariant(AST _t) throws RecognitionException {
		 String inv ;

		AST invariant_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST invariant_AST = null;

		String bfunc;

		inv = "";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case INVARIANT:
			{
				AST __t77 = _t;
				AST tmp24_AST = null;
				AST tmp24_AST_in = null;
				tmp24_AST = (AST)astFactory.create((AST)_t);
				tmp24_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp24_AST);
				ASTPair __currentAST77 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,INVARIANT);
				_t = _t.getFirstChild();
				bfunc=boolean_function(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST77;
				_t = __t77;
				_t = _t.getNextSibling();

				inv = bfunc;

				invariant_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case PAR_CONSTRAINT:
			case TRANSITIONS:
			{
				;
				invariant_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = invariant_AST;
		_retTree = _t;
		return inv ;
	}

	public final  String  parameter_constraint(AST _t) throws RecognitionException {
		 String par_con ;

		AST parameter_constraint_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST parameter_constraint_AST = null;

		String bfunc;

		par_con = " ";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PAR_CONSTRAINT:
			{
				AST __t79 = _t;
				AST tmp25_AST = null;
				AST tmp25_AST_in = null;
				tmp25_AST = (AST)astFactory.create((AST)_t);
				tmp25_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp25_AST);
				ASTPair __currentAST79 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,PAR_CONSTRAINT);
				_t = _t.getFirstChild();
				bfunc=boolean_function(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST79;
				_t = __t79;
				_t = _t.getNextSibling();

				par_con = bfunc;

				parameter_constraint_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case TRANSITIONS:
			{
				;
				parameter_constraint_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = parameter_constraint_AST;
		_retTree = _t;
		return par_con ;
	}

	public final  Vector  transition_list(AST _t) throws RecognitionException {
		 Vector tlist ;

		AST transition_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST transition_list_AST = null;

		_transition trans;
		tlist = new Vector(3,2);

		Vector temp_tlist;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case TRANSITIONS:
			{
				AST __t81 = _t;
				AST tmp26_AST = null;
				AST tmp26_AST_in = null;
				tmp26_AST = (AST)astFactory.create((AST)_t);
				tmp26_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp26_AST);
				ASTPair __currentAST81 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,TRANSITIONS);
				_t = _t.getFirstChild();
				trans=transition(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_tlist=transition_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST81;
				_t = __t81;
				_t = _t.getNextSibling();

				temp_tlist.addElement(trans);
				tlist = temp_tlist;

				transition_list_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				transition_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = transition_list_AST;
		_retTree = _t;
		return tlist ;
	}

	public final  Vector  rate_list(AST _t) throws RecognitionException {
		 Vector rlist ;

		AST rate_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rate_list_AST = null;

		float f;
		Vector f_list;

		rlist = new Vector(3,2);


		try {      // for error handling
			AST __t47 = _t;
			AST tmp27_AST = null;
			AST tmp27_AST_in = null;
			tmp27_AST = (AST)astFactory.create((AST)_t);
			tmp27_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp27_AST);
			ASTPair __currentAST47 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,SEMI);
			_t = _t.getFirstChild();
			f=fnumber(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			f_list=fnumber_list_entries(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST47;
			_t = __t47;
			_t = _t.getNextSibling();

			f_list.addElement(new Float(f));
			rlist = f_list;

			rate_list_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = rate_list_AST;
		_retTree = _t;
		return rlist ;
	}

	public final  _linearmap  linearmap(AST _t) throws RecognitionException {
		 _linearmap lmap ;

		AST linearmap_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST linearmap_AST = null;

		float f;
		Vector v;

		Vector vec; // A vector of 'Float Vectors'
		Vector lin_fvec;

		lmap = new _linearmap();


		try {      // for error handling
			AST __t49 = _t;
			AST tmp28_AST = null;
			AST tmp28_AST_in = null;
			tmp28_AST = (AST)astFactory.create((AST)_t);
			tmp28_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp28_AST);
			ASTPair __currentAST49 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,COMMA);
			_t = _t.getFirstChild();
			v=vector(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			vec=linearmap_vectors(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			f=fnumber(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			lin_fvec=linearmap_fnumbers(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST49;
			_t = __t49;
			_t = _t.getNextSibling();

			vec.addElement(v);
			lin_fvec.addElement(new Float(f));
			lmap = new _linearmap(vec,lin_fvec);

			linearmap_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = linearmap_AST;
		_retTree = _t;
		return lmap ;
	}

	public final  Vector  nonlinearmap(AST _t) throws RecognitionException {
		 Vector nlmap ;

		AST nonlinearmap_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST nonlinearmap_AST = null;

		nlmap = new Vector(3,2);

		Vector temp_nlmap;
		String ode;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SEMI:
			{
				AST __t55 = _t;
				AST tmp29_AST = null;
				AST tmp29_AST_in = null;
				tmp29_AST = (AST)astFactory.create((AST)_t);
				tmp29_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp29_AST);
				ASTPair __currentAST55 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,SEMI);
				_t = _t.getFirstChild();
				ode=ode_rhs(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_nlmap=nonlinearmap(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST55;
				_t = __t55;
				_t = _t.getNextSibling();

				temp_nlmap.addElement(ode);
				nlmap = temp_nlmap;

				nonlinearmap_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				nonlinearmap_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = nonlinearmap_AST;
		_retTree = _t;
		return nlmap ;
	}

	public final  Vector  linearmap_vectors(AST _t) throws RecognitionException {
		 Vector vec ;

		AST linearmap_vectors_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST linearmap_vectors_AST = null;

		Vector v; // a vector of Floats
		Vector lvec;

		lvec = new Vector(3,2); // These are vectors of vectors
		vec = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SEMI:
			{
				AST __t51 = _t;
				AST tmp30_AST = null;
				AST tmp30_AST_in = null;
				tmp30_AST = (AST)astFactory.create((AST)_t);
				tmp30_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp30_AST);
				ASTPair __currentAST51 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,SEMI);
				_t = _t.getFirstChild();
				v=vector(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				lvec=linearmap_vectors(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST51;
				_t = __t51;
				_t = _t.getNextSibling();

				lvec.addElement(v);
				vec = lvec;

				linearmap_vectors_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case OP:
			case FLOAT:
			{
				;
				linearmap_vectors_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = linearmap_vectors_AST;
		_retTree = _t;
		return vec ;
	}

	public final  Vector  linearmap_fnumbers(AST _t) throws RecognitionException {
		 Vector lin_fvec ;

		AST linearmap_fnumbers_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST linearmap_fnumbers_AST = null;

		float f;

		Vector lfn;
		lin_fvec = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SEMI:
			{
				AST __t53 = _t;
				AST tmp31_AST = null;
				AST tmp31_AST_in = null;
				tmp31_AST = (AST)astFactory.create((AST)_t);
				tmp31_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp31_AST);
				ASTPair __currentAST53 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,SEMI);
				_t = _t.getFirstChild();
				f=fnumber(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				lfn=linearmap_fnumbers(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST53;
				_t = __t53;
				_t = _t.getNextSibling();

				lfn.addElement(new Float(f));
				lin_fvec = lfn;

				linearmap_fnumbers_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				linearmap_fnumbers_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = linearmap_fnumbers_AST;
		_retTree = _t;
		return lin_fvec ;
	}

	public final  String  ode_rhs(AST _t) throws RecognitionException {
		 String ode ;

		AST ode_rhs_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ode_rhs_AST = null;
		AST c = null;
		AST c_AST = null;

		String exp1, exp2;

		ode = " ";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case OP:
			{
				AST __t57 = _t;
				c = _t==ASTNULL ? null :(AST)_t;
				c_AST = (AST)astFactory.create(c);
				astFactory.addASTChild(currentAST, c_AST);
				ASTPair __currentAST57 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,OP);
				_t = _t.getFirstChild();
				exp1=expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST57;
				_t = __t57;
				_t = _t.getNextSibling();
				ode = c + exp1 ;
				ode_rhs_AST = (AST)currentAST.root;
				break;
			}
			case ODE_RHS_IMG:
			{
				AST __t58 = _t;
				AST tmp32_AST = null;
				AST tmp32_AST_in = null;
				tmp32_AST = (AST)astFactory.create((AST)_t);
				tmp32_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp32_AST);
				ASTPair __currentAST58 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,ODE_RHS_IMG);
				_t = _t.getFirstChild();
				exp2=expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST58;
				_t = __t58;
				_t = _t.getNextSibling();
				ode = exp2;
				ode_rhs_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = ode_rhs_AST;
		_retTree = _t;
		return ode ;
	}

	public final  String  expr(AST _t) throws RecognitionException {
		 String exp ;

		AST expr_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expr_AST = null;

		String uexp, exp_list;

		exp = " ";


		try {      // for error handling
			AST __t60 = _t;
			AST tmp33_AST = null;
			AST tmp33_AST_in = null;
			tmp33_AST = (AST)astFactory.create((AST)_t);
			tmp33_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp33_AST);
			ASTPair __currentAST60 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,EXPR_IMG);
			_t = _t.getFirstChild();
			uexp=u_expr(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			exp_list=expr_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST60;
			_t = __t60;
			_t = _t.getNextSibling();

			exp = uexp + exp_list;

			expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = expr_AST;
		_retTree = _t;
		return exp ;
	}

	public final  String  u_expr(AST _t) throws RecognitionException {
		 String uexp ;

		AST u_expr_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST u_expr_AST = null;

		float f;

		String func, str_exp;

		uexp = "";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case U_EXPR_IMG:
			{
				AST __t64 = _t;
				AST tmp34_AST = null;
				AST tmp34_AST_in = null;
				tmp34_AST = (AST)astFactory.create((AST)_t);
				tmp34_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp34_AST);
				ASTPair __currentAST64 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,U_EXPR_IMG);
				_t = _t.getFirstChild();
				func=function(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST64;
				_t = __t64;
				_t = _t.getNextSibling();
				uexp = func ;
				u_expr_AST = (AST)currentAST.root;
				break;
			}
			case U_EXPR_IMG2:
			{
				AST __t65 = _t;
				AST tmp35_AST = null;
				AST tmp35_AST_in = null;
				tmp35_AST = (AST)astFactory.create((AST)_t);
				tmp35_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp35_AST);
				ASTPair __currentAST65 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,U_EXPR_IMG2);
				_t = _t.getFirstChild();
				f=fnumber(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST65;
				_t = __t65;
				_t = _t.getNextSibling();
				uexp = f + " ";
				u_expr_AST = (AST)currentAST.root;
				break;
			}
			case LEFTPAREN:
			{
				AST __t66 = _t;
				AST tmp36_AST = null;
				AST tmp36_AST_in = null;
				tmp36_AST = (AST)astFactory.create((AST)_t);
				tmp36_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp36_AST);
				ASTPair __currentAST66 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,LEFTPAREN);
				_t = _t.getFirstChild();
				str_exp=expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				AST tmp37_AST = null;
				AST tmp37_AST_in = null;
				tmp37_AST = (AST)astFactory.create((AST)_t);
				tmp37_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp37_AST);
				match(_t,RIGHTPAREN);
				_t = _t.getNextSibling();
				currentAST = __currentAST66;
				_t = __t66;
				_t = _t.getNextSibling();

				uexp = "(" + str_exp + ")" ;

				u_expr_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = u_expr_AST;
		_retTree = _t;
		return uexp ;
	}

	public final  String  expr_list(AST _t) throws RecognitionException {
		 String explist ;

		AST expr_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expr_list_AST = null;
		AST c = null;
		AST c_AST = null;

		String uexp, temp_explist;

		explist = " ";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case OP:
			{
				AST __t62 = _t;
				c = _t==ASTNULL ? null :(AST)_t;
				c_AST = (AST)astFactory.create(c);
				astFactory.addASTChild(currentAST, c_AST);
				ASTPair __currentAST62 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,OP);
				_t = _t.getFirstChild();
				uexp=u_expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_explist=expr_list(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST62;
				_t = __t62;
				_t = _t.getNextSibling();

				explist = c + uexp + temp_explist + " ";

				expr_list_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				expr_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = expr_list_AST;
		_retTree = _t;
		return explist ;
	}

	public final  String  function(AST _t) throws RecognitionException {
		 String func ;

		AST function_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST function_AST = null;
		AST s = null;
		AST s_AST = null;

		func = "";

		String a_args;


		try {      // for error handling
			AST __t68 = _t;
			s = _t==ASTNULL ? null :(AST)_t;
			s_AST = (AST)astFactory.create(s);
			astFactory.addASTChild(currentAST, s_AST);
			ASTPair __currentAST68 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,STRING);
			_t = _t.getFirstChild();
			a_args=a_arguments(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST68;
			_t = __t68;
			_t = _t.getNextSibling();

				                       func = s + "("+a_args+")";

			function_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = function_AST;
		_retTree = _t;
		return func ;
	}

	public final  String  a_arguments(AST _t) throws RecognitionException {
		 String a_args ;

		AST a_arguments_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST a_arguments_AST = null;

		a_args = "";

		String a_arg, a_arglist;


		try {      // for error handling
			AST __t70 = _t;
			AST tmp38_AST = null;
			AST tmp38_AST_in = null;
			tmp38_AST = (AST)astFactory.create((AST)_t);
			tmp38_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp38_AST);
			ASTPair __currentAST70 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,A_ARGUMENTS_IMG);
			_t = _t.getFirstChild();
			a_arg=a_argument(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			a_arglist=a_arguments_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST70;
			_t = __t70;
			_t = _t.getNextSibling();

			a_args = a_arg + " " +a_arglist;

			a_arguments_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = a_arguments_AST;
		_retTree = _t;
		return a_args ;
	}

	public final  String  a_argument(AST _t) throws RecognitionException {
		 String a_arg ;

		AST a_argument_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST a_argument_AST = null;

		float f;

		a_arg = "";

		String func;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case A_ARGUMENT1_IMG:
			{
				AST __t74 = _t;
				AST tmp39_AST = null;
				AST tmp39_AST_in = null;
				tmp39_AST = (AST)astFactory.create((AST)_t);
				tmp39_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp39_AST);
				ASTPair __currentAST74 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,A_ARGUMENT1_IMG);
				_t = _t.getFirstChild();
				f=fnumber(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST74;
				_t = __t74;
				_t = _t.getNextSibling();

				a_arg = f + "";

				a_argument_AST = (AST)currentAST.root;
				break;
			}
			case A_ARGUMENT2_IMG:
			{
				AST __t75 = _t;
				AST tmp40_AST = null;
				AST tmp40_AST_in = null;
				tmp40_AST = (AST)astFactory.create((AST)_t);
				tmp40_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp40_AST);
				ASTPair __currentAST75 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,A_ARGUMENT2_IMG);
				_t = _t.getFirstChild();
				func=function(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST75;
				_t = __t75;
				_t = _t.getNextSibling();

				a_arg = func;

				a_argument_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = a_argument_AST;
		_retTree = _t;
		return a_arg ;
	}

	public final  String  a_arguments_list(AST _t) throws RecognitionException {
		 String a_arglist ;

		AST a_arguments_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST a_arguments_list_AST = null;

		a_arglist = "";

		String a_arg, temp_a_arglist;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case COMMA:
			{
				AST __t72 = _t;
				AST tmp41_AST = null;
				AST tmp41_AST_in = null;
				tmp41_AST = (AST)astFactory.create((AST)_t);
				tmp41_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp41_AST);
				ASTPair __currentAST72 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,COMMA);
				_t = _t.getFirstChild();
				a_arg=a_argument(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_a_arglist=a_arguments_list(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST72;
				_t = __t72;
				_t = _t.getNextSibling();

				a_arglist = a_arg +" "+ temp_a_arglist;

				a_arguments_list_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				a_arguments_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = a_arguments_list_AST;
		_retTree = _t;
		return a_arglist ;
	}

	public final  String  boolean_function(AST _t) throws RecognitionException {
		 String bfunc ;

		AST boolean_function_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST boolean_function_AST = null;

		String larg;
		String bflist;

		bfunc = " ";


		try {      // for error handling
			AST __t103 = _t;
			AST tmp42_AST = null;
			AST tmp42_AST_in = null;
			tmp42_AST = (AST)astFactory.create((AST)_t);
			tmp42_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp42_AST);
			ASTPair __currentAST103 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,BOOL_FUNC);
			_t = _t.getFirstChild();
			larg=l_argument(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			bflist=bool_func_list(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST103;
			_t = __t103;
			_t = _t.getNextSibling();

			bfunc = larg + bflist;

			boolean_function_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = boolean_function_AST;
		_retTree = _t;
		return bfunc ;
	}

	public final  _transition  transition(AST _t) throws RecognitionException {
		 _transition trans ;

		AST transition_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST transition_AST = null;
		AST s = null;
		AST s_AST = null;

		String t, c, grd,oe;
		_linearmap rmap;
		String ie;

		trans = new _transition();


		try {      // for error handling
			AST __t85 = _t;
			s = _t==ASTNULL ? null :(AST)_t;
			s_AST = (AST)astFactory.create(s);
			astFactory.addASTChild(currentAST, s_AST);
			ASTPair __currentAST85 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,STRING);
			_t = _t.getFirstChild();
			t=target(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			grd=guard(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			rmap=reset(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			c=clock_flag(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			ie=ievent(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			oe=oevent(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST85;
			_t = __t85;
			_t = _t.getNextSibling();

			if(!ie.equals("")){
			trans = new  _transition(
			s.toString(), t, grd, rmap, c, oe, 1);
			}
			else{
			trans = new  _transition(
			s.toString(), t, grd, rmap, c, oe, 0);
			}

			// ie is being ignored .. it is assumed to be in
			// the guard.
			// System.out.println("Making transition");
			// System.out.println("resetmap.vecs.size = " + rmap.vecs.size() );

			transition_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = transition_AST;
		_retTree = _t;
		return trans ;
	}

	public final  Vector  transition_list_entries(AST _t) throws RecognitionException {
		 Vector tliste ;

		AST transition_list_entries_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST transition_list_entries_AST = null;

		_transition trans;

		Vector temp_tlist; // Vector of transitions

		tliste = new Vector(3,2);


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case TRANSITION_LIST_ENTRIES_IMG:
			{
				AST __t83 = _t;
				AST tmp43_AST = null;
				AST tmp43_AST_in = null;
				tmp43_AST = (AST)astFactory.create((AST)_t);
				tmp43_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp43_AST);
				ASTPair __currentAST83 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,TRANSITION_LIST_ENTRIES_IMG);
				_t = _t.getFirstChild();
				trans=transition(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_tlist=transition_list_entries(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST83;
				_t = __t83;
				_t = _t.getNextSibling();

				temp_tlist.addElement(trans);
				tliste = temp_tlist;

				transition_list_entries_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				transition_list_entries_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = transition_list_entries_AST;
		_retTree = _t;
		return tliste ;
	}

	public final  String  target(AST _t) throws RecognitionException {
		 String s ;

		AST target_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST target_AST = null;
		AST a = null;
		AST a_AST = null;

		s = new String();


		try {      // for error handling
			AST __t91 = _t;
			AST tmp44_AST = null;
			AST tmp44_AST_in = null;
			tmp44_AST = (AST)astFactory.create((AST)_t);
			tmp44_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp44_AST);
			ASTPair __currentAST91 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,TARGET);
			_t = _t.getFirstChild();
			a = (AST)_t;
			a_AST = (AST)astFactory.create(a);
			astFactory.addASTChild(currentAST, a_AST);
			match(_t,STRING);
			_t = _t.getNextSibling();
			currentAST = __currentAST91;
			_t = __t91;
			_t = _t.getNextSibling();
			s = new String(a.toString());
			target_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = target_AST;
		_retTree = _t;
		return s ;
	}

	public final  String  guard(AST _t) throws RecognitionException {
		 String grd ;

		AST guard_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST guard_AST = null;

		String bfunc;

		grd = " ";


		try {      // for error handling
			AST __t93 = _t;
			AST tmp45_AST = null;
			AST tmp45_AST_in = null;
			tmp45_AST = (AST)astFactory.create((AST)_t);
			tmp45_AST_in = (AST)_t;
			astFactory.addASTChild(currentAST, tmp45_AST);
			ASTPair __currentAST93 = currentAST.copy();
			currentAST.root = currentAST.child;
			currentAST.child = null;
			match(_t,GUARD);
			_t = _t.getFirstChild();
			bfunc=boolean_function(_t);
			_t = _retTree;
			astFactory.addASTChild(currentAST, returnAST);
			currentAST = __currentAST93;
			_t = __t93;
			_t = _t.getNextSibling();

			grd = bfunc;

			guard_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = guard_AST;
		_retTree = _t;
		return grd ;
	}

	public final  _linearmap  reset(AST _t) throws RecognitionException {
		 _linearmap rmap ;

		AST reset_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST reset_AST = null;

		_linearmap lmap;

		rmap = new _linearmap();


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case RESET:
			{
				AST __t95 = _t;
				AST tmp46_AST = null;
				AST tmp46_AST_in = null;
				tmp46_AST = (AST)astFactory.create((AST)_t);
				tmp46_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp46_AST);
				ASTPair __currentAST95 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,RESET);
				_t = _t.getFirstChild();
				lmap=linearmap(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST95;
				_t = __t95;
				_t = _t.getNextSibling();

				rmap = lmap;
				// System.out.println("Found reset");

				reset_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case CLOCK:
			case IEVENT:
			case OEVENT:
			{
				;
				reset_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = reset_AST;
		_retTree = _t;
		return rmap ;
	}

	public final  String  clock_flag(AST _t) throws RecognitionException {
		 String s ;

		AST clock_flag_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST clock_flag_AST = null;
		AST a = null;
		AST a_AST = null;

		s = new String();


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case CLOCK:
			{
				AST __t97 = _t;
				AST tmp47_AST = null;
				AST tmp47_AST_in = null;
				tmp47_AST = (AST)astFactory.create((AST)_t);
				tmp47_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp47_AST);
				ASTPair __currentAST97 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,CLOCK);
				_t = _t.getFirstChild();
				a = (AST)_t;
				a_AST = (AST)astFactory.create(a);
				astFactory.addASTChild(currentAST, a_AST);
				match(_t,STRING);
				_t = _t.getNextSibling();
				currentAST = __currentAST97;
				_t = __t97;
				_t = _t.getNextSibling();
				s = new String(a.toString());
				clock_flag_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case IEVENT:
			case OEVENT:
			{
				clock_flag_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = clock_flag_AST;
		_retTree = _t;
		return s ;
	}

	public final  String  ievent(AST _t) throws RecognitionException {
		 String ie;

		AST ievent_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ievent_AST = null;
		AST s = null;
		AST s_AST = null;

		ie = "";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IEVENT:
			{
				AST __t87 = _t;
				AST tmp48_AST = null;
				AST tmp48_AST_in = null;
				tmp48_AST = (AST)astFactory.create((AST)_t);
				tmp48_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp48_AST);
				ASTPair __currentAST87 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,IEVENT);
				_t = _t.getFirstChild();
				s = (AST)_t;
				s_AST = (AST)astFactory.create(s);
				astFactory.addASTChild(currentAST, s_AST);
				match(_t,STRING);
				_t = _t.getNextSibling();
				currentAST = __currentAST87;
				_t = __t87;
				_t = _t.getNextSibling();

				ie = s.toString();

				ievent_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			case OEVENT:
			{
				ievent_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = ievent_AST;
		_retTree = _t;
		return ie;
	}

	public final  String  oevent(AST _t) throws RecognitionException {
		 String oe ;

		AST oevent_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST oevent_AST = null;
		AST s = null;
		AST s_AST = null;

		oe = "";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case OEVENT:
			{
				AST __t89 = _t;
				AST tmp49_AST = null;
				AST tmp49_AST_in = null;
				tmp49_AST = (AST)astFactory.create((AST)_t);
				tmp49_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp49_AST);
				ASTPair __currentAST89 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,OEVENT);
				_t = _t.getFirstChild();
				s = (AST)_t;
				s_AST = (AST)astFactory.create(s);
				astFactory.addASTChild(currentAST, s_AST);
				match(_t,STRING);
				_t = _t.getNextSibling();
				currentAST = __currentAST89;
				_t = __t89;
				_t = _t.getNextSibling();
				oe = s.toString();
				oevent_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				oevent_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = oevent_AST;
		_retTree = _t;
		return oe ;
	}

	public final  String  l_argument(AST _t) throws RecognitionException {
		 String ret_larg ;

		AST l_argument_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST l_argument_AST = null;
		AST s = null;
		AST s_AST = null;

		ret_larg = " ";
		String temp_larg, larg_1, temp2_larg, larg_2;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LEFTPAREN:
			{
				AST __t107 = _t;
				AST tmp50_AST = null;
				AST tmp50_AST_in = null;
				tmp50_AST = (AST)astFactory.create((AST)_t);
				tmp50_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp50_AST);
				ASTPair __currentAST107 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,LEFTPAREN);
				_t = _t.getFirstChild();
				temp_larg=l_argument(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				AST tmp51_AST = null;
				AST tmp51_AST_in = null;
				tmp51_AST = (AST)astFactory.create((AST)_t);
				tmp51_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp51_AST);
				match(_t,RIGHTPAREN);
				_t = _t.getNextSibling();
				larg_1=l_argument_one(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST107;
				_t = __t107;
				_t = _t.getNextSibling();

				ret_larg = "(" + temp_larg + ")" + larg_1 ;

				l_argument_AST = (AST)currentAST.root;
				break;
			}
			case NOT:
			{
				AST __t108 = _t;
				AST tmp52_AST = null;
				AST tmp52_AST_in = null;
				tmp52_AST = (AST)astFactory.create((AST)_t);
				tmp52_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp52_AST);
				ASTPair __currentAST108 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,NOT);
				_t = _t.getFirstChild();
				temp2_larg=l_argument(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST108;
				_t = __t108;
				_t = _t.getNextSibling();

				ret_larg = "~" + temp2_larg ;

				l_argument_AST = (AST)currentAST.root;
				break;
			}
			case STRING:
			{
				AST __t109 = _t;
				s = _t==ASTNULL ? null :(AST)_t;
				s_AST = (AST)astFactory.create(s);
				astFactory.addASTChild(currentAST, s_AST);
				ASTPair __currentAST109 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,STRING);
				_t = _t.getFirstChild();
				larg_2=l_argument_two(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST109;
				_t = __t109;
				_t = _t.getNextSibling();

				ret_larg = s + larg_2 ;

				l_argument_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = l_argument_AST;
		_retTree = _t;
		return ret_larg ;
	}

	public final  String  bool_func_list(AST _t) throws RecognitionException {
		 String bflist ;

		AST bool_func_list_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST bool_func_list_AST = null;

		char o;
		String larg;
		String temp_bflist;

		bflist = " ";


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case BOOL_FUNC_LIST_IMG:
			{
				AST __t105 = _t;
				AST tmp53_AST = null;
				AST tmp53_AST_in = null;
				tmp53_AST = (AST)astFactory.create((AST)_t);
				tmp53_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp53_AST);
				ASTPair __currentAST105 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,BOOL_FUNC_LIST_IMG);
				_t = _t.getFirstChild();
				o=operator(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				larg=l_argument(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				temp_bflist=bool_func_list(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST105;
				_t = __t105;
				_t = _t.getNextSibling();

				bflist = o + larg + temp_bflist;

				bool_func_list_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				bool_func_list_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = bool_func_list_AST;
		_retTree = _t;
		return bflist ;
	}

	public final  char  operator(AST _t) throws RecognitionException {
		 char c ;

		AST operator_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST operator_AST = null;

		c = ' ';


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AND:
			{
				AST tmp54_AST = null;
				AST tmp54_AST_in = null;
				tmp54_AST = (AST)astFactory.create((AST)_t);
				tmp54_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp54_AST);
				match(_t,AND);
				_t = _t.getNextSibling();
				c = '&';
				operator_AST = (AST)currentAST.root;
				break;
			}
			case OR:
			{
				AST tmp55_AST = null;
				AST tmp55_AST_in = null;
				tmp55_AST = (AST)astFactory.create((AST)_t);
				tmp55_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp55_AST);
				match(_t,OR);
				_t = _t.getNextSibling();
				c = '|';
				operator_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = operator_AST;
		_retTree = _t;
		return c ;
	}

	public final  String  l_argument_one(AST _t) throws RecognitionException {
		 String larg_1 ;

		AST l_argument_one_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST l_argument_one_AST = null;

		char o;
		larg_1 = " ";
		String larg;
		String larg_one;



		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case L_ARGUMENT_1_IMG:
			{
				AST __t111 = _t;
				AST tmp56_AST = null;
				AST tmp56_AST_in = null;
				tmp56_AST = (AST)astFactory.create((AST)_t);
				tmp56_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp56_AST);
				ASTPair __currentAST111 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,L_ARGUMENT_1_IMG);
				_t = _t.getFirstChild();
				o=operator(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				larg=l_argument(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				larg_one=l_argument_one(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST111;
				_t = __t111;
				_t = _t.getNextSibling();
				larg_1 = o + larg + larg_one;
				l_argument_one_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				l_argument_one_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = l_argument_one_AST;
		_retTree = _t;
		return larg_1 ;
	}

	public final  String  l_argument_two(AST _t) throws RecognitionException {
		 String larg_2 ;

		AST l_argument_two_AST_in = (AST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST l_argument_two_AST = null;

		char o;
		larg_2 = " ";
		String larg;


		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case L_ARGUMENT_2_IMG:
			{
				AST __t113 = _t;
				AST tmp57_AST = null;
				AST tmp57_AST_in = null;
				tmp57_AST = (AST)astFactory.create((AST)_t);
				tmp57_AST_in = (AST)_t;
				astFactory.addASTChild(currentAST, tmp57_AST);
				ASTPair __currentAST113 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,L_ARGUMENT_2_IMG);
				_t = _t.getFirstChild();
				o=operator(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				larg=l_argument(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST113;
				_t = __t113;
				_t = _t.getNextSibling();
				larg_2 = o + larg ;
				l_argument_two_AST = (AST)currentAST.root;
				break;
			}
			case 3:
			{
				;
				l_argument_two_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		returnAST = l_argument_two_AST;
		_retTree = _t;
		return larg_2 ;
	}


	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"BOOL_FUNC",
		"VECTOR_IMG",
		"MACHINE_LIST_ENTRIES_IMG",
		"LOCATION_LIST_ENTRIES_IMG",
		"TRANSITION_LIST_ENTRIES_IMG",
		"HALFSPACE_LIST_ENTRIES_IMG",
		"ODE_RHS_IMG",
		"EXPR_IMG",
		"U_EXPR_IMG",
		"U_EXPR_IMG2",
		"A_ARGUMENTS_IMG",
		"A_ARGUMENT1_IMG",
		"A_ARGUMENT2_IMG",
		"BOOL_FUNC_LIST_IMG",
		"L_ARGUMENT_1_IMG",
		"L_ARGUMENT_2_IMG",
		"LEFTBRACE",
		"RIGHTBRACE",
		"STRING",
		"\"VARIABLES\"",
		"COLON",
		"SEMI",
		"\"PARAMETERS\"",
		"\"HALFSPACES\"",
		"LEFTBRACKET",
		"RIGHTBRACKET",
		"COMMA",
		"\"MACHINE\"",
		"\"EVENTS\"",
		"\"VARIABLE\"",
		"\"LOCATIONS\"",
		"\"INITIAL_LOCATION\"",
		"\"INTEGRATOR\"",
		"\"LINEAR\"",
		"\"NONLINEAR\"",
		"OP",
		"LEFTPAREN",
		"RIGHTPAREN",
		"\"INVARIANT\"",
		"AND",
		"OR",
		"NOT",
		"SMALLER",
		"GREATER",
		"EQUAL",
		"\"PAR_CONSTRAINT\"",
		"\"TRANSITIONS\"",
		"\"TARGET\"",
		"\"GUARD\"",
		"\"RESET\"",
		"\"CLOCK\"",
		"\"IEVENT\"",
		"\"OEVENT\"",
		"\"ANALYSIS_REGION\"",
		"\"INITIAL_SET\"",
		"FLOAT",
		"\"MODEL\"",
		"\"CLOCKS\"",
		"\"OEVTS\"",
		"\"IEVTS\"",
		"WS",
		"SL_COMMENT",
		"ML_COMMENT",
		"DIGIT",
		"LETTER",
		"INT"
	};

	}

